Scala Compiler2.13.0 < Back


# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package typechecker
  Definition Classes
    nsc
-  trait Contexts extends AnyRef

  Definition Classes
    typechecker
  Version

    1.0

- Context
- ContextReporter
- ImportContext
- ImportInfo
- NoContext

c

scala.tools.nsc.typechecker.Contexts

# ContextReporter

###

#### abstract class ContextReporter extends Reporter

A reporter for use during type checking. It has multiple modes for handling errors.

The default (immediate mode) is to send the error to the global reporter. When switched into buffering mode via makeBuffering, errors and warnings are buffered and not be reported (there's a special case for ambiguity errors for some reason: those are force to the reporter when context.ambiguousErrors, or else they are buffered -- TODO: can we simplify this?)

When using the type checker after typers, an error results in a TypeError being thrown. TODO: get rid of this mode.

To handle nested contexts, reporters share buffers. TODO: only buffer in BufferingReporter, emit immediately in ImmediateReporter

Source
  Contexts.scala

Linear Supertypes
Reporter, AnyRef, Any
Type Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. ContextReporter
2. Reporter
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1.  new ContextReporter(_errorBuffer: LinkedHashSet[Analyzer.AbsTypeError] = null, _warningBuffer: LinkedHashSet[(Global.Position, String)] = null)

### Type Members

1.  type Error = Analyzer.AbsTypeError
2.  class Severity extends AnyRef
   Definition Classes
     Reporter
3.  type Warning = (Global.Position, String)

### Abstract Value Members

1.  abstract def handleError(pos: Global.Position, msg: String): Unit
   Attributes
     protected

### Concrete Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from Analyzer.ContextReporter toany2stringadd[Analyzer.ContextReporter] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (Analyzer.ContextReporter, B)
   Implicit
     This member is added by an implicit conversion from Analyzer.ContextReporter toArrowAssoc[Analyzer.ContextReporter] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  def addDiagString(msg: String)(implicit context: Analyzer.Context): String
   Attributes
     protected
7.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
8.  final def clearAll(): Unit
9.  final def clearAllErrors(): Unit
10.  def clone(): AnyRef
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.CloneNotSupportedException]) @native()
11.  def count(severity: Severity): Int
    Definition Classes
      Reporter
12.  def echo(pos: Position, msg: String): Unit
    Definition Classes
      Reporter
13.  def echo(msg: String): Unit
    Definition Classes
      Reporter
14.  final def emitWarnings(): Unit
15.  def ensuring(cond: (Analyzer.ContextReporter) => Boolean, msg: => Any): Analyzer.ContextReporter
    Implicit
      This member is added by an implicit conversion from Analyzer.ContextReporter toEnsuring[Analyzer.ContextReporter] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
16.  def ensuring(cond: (Analyzer.ContextReporter) => Boolean): Analyzer.ContextReporter
    Implicit
      This member is added by an implicit conversion from Analyzer.ContextReporter toEnsuring[Analyzer.ContextReporter] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
17.  def ensuring(cond: Boolean, msg: => Any): Analyzer.ContextReporter
    Implicit
      This member is added by an implicit conversion from Analyzer.ContextReporter toEnsuring[Analyzer.ContextReporter] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
18.  def ensuring(cond: Boolean): Analyzer.ContextReporter
    Implicit
      This member is added by an implicit conversion from Analyzer.ContextReporter toEnsuring[Analyzer.ContextReporter] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
19.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
20.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
21.  def error(pos: Position, msg: String): Unit
    Definition Classes
      Reporter
22.  final def errorBuffer: LinkedHashSet[Analyzer.AbsTypeError]
    Attributes
      protected
23.  def errorCount: Int
    Definition Classes
      Reporter
24.  final def errors: collection.immutable.Seq[Error]
25.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
26.  def finish(): Unit
    Definition Classes
      Reporter
27.  final def firstError: Option[Analyzer.AbsTypeError]
28.  def flush(): Unit
    Definition Classes
      Reporter
29.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from Analyzer.ContextReporter toStringFormat[Analyzer.ContextReporter] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
30.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
31.  def handleSuppressedAmbiguous(err: Analyzer.AbsAmbiguousTypeError): Unit
    Attributes
      protected
32.  def handleWarning(pos: Global.Position, msg: String): Unit
    Attributes
      protected
33.  final def hasErrors: Boolean
    Definition Classes
      ContextReporter → Reporter
34.  def hasWarnings: Boolean
    Definition Classes
      Reporter
35.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
36.  final def info0(pos: Global.Position, msg: String, severity: Severity, force: Boolean): Unit
    Attributes
      protected
    Definition Classes
      ContextReporter → Reporter
37.  def isBuffering: Boolean
38.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
39.  def isThrowing: Boolean
40.  def issue(err: Analyzer.AbsTypeError)(implicit context: Analyzer.Context): Unit
41.  final def issueAmbiguousError(err: Analyzer.AbsAmbiguousTypeError)(implicit context: Analyzer.Context): Unit

    Emit an ambiguous error according to context.ambiguousErrors

    Emit an ambiguous error according to context.ambiguousErrors

    - when true, use global.reporter regardless of whether we're buffering (TODO: can we change this?)
    - else, let this context reporter decide
42.  def makeBuffering: Analyzer.ContextReporter
43.  def makeImmediate: Analyzer.ContextReporter
44.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
45.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
46.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
47.  final def propagateErrorsTo[T](target: Analyzer.ContextReporter): Unit
48.  def propagateImplicitTypeErrorsTo(target: Analyzer.ContextReporter): Unit
49.  def reportFirstDivergentError(fun: Global.Tree, param: Global.Symbol, paramTp: Global.Type)(implicit context: Analyzer.Context): Unit
50.  def rerunWithDetails(setting: Setting, name: String): String
    Definition Classes
      Reporter
51.  def reset(): Unit
    Definition Classes
      Reporter
52.  def resetCount(severity: Severity): Unit
    Definition Classes
      Reporter
53.  def retainDivergentErrorsExcept(saved: Analyzer.DivergentImplicitTypeError): Unit
54.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
55.  def toString(): String
    Definition Classes
      AnyRef → Any
56.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
57.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
58.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()
59.  def warning(pos: Position, msg: String): Unit
    Definition Classes
      Reporter
60.  final def warningBuffer: LinkedHashSet[(Global.Position, String)]
    Attributes
      protected
61.  def warningCount: Int
    Definition Classes
      Reporter
62.  final def warnings: collection.immutable.Seq[Warning]
63.  final def withFreshErrorBuffer[T](expr: => T): T
    Annotations
      @inline()
64.  object ERROR extends Severity
    Definition Classes
      Reporter
65.  object INFO extends Severity
    Definition Classes
      Reporter
66.  object WARNING extends Severity
    Definition Classes
      Reporter

### Deprecated Value Members

1.  def →[B](y: B): (Analyzer.ContextReporter, B)
   Implicit
     This member is added by an implicit conversion from Analyzer.ContextReporter toArrowAssoc[Analyzer.ContextReporter] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `->` instead. If you still wish to display it as one character, consider using a font with programming ligatures such as Fira Code.

### Inherited from Reporter

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd fromAnalyzer.ContextReporter to any2stringadd[Analyzer.ContextReporter]

### Inherited by implicit conversion StringFormat fromAnalyzer.ContextReporter to StringFormat[Analyzer.ContextReporter]

### Inherited by implicit conversion Ensuring fromAnalyzer.ContextReporter to Ensuring[Analyzer.ContextReporter]

### Inherited by implicit conversion ArrowAssoc fromAnalyzer.ContextReporter to ArrowAssoc[Analyzer.ContextReporter]

### Ungrouped